## rtpulpfecdec rtpulpfecdec — Generic RTP Forward Error Correction (FEC) decoder |

## Properties

guint | pt | Read / Write
guint | recovered | Read
GObject * | storage | Read / Write
guint | unrecovered | Read

## Types and Values

struct | GstRtpUlpFecDec

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstRtpUlpFecDec

## Description

Generic Forward Error Correction (FEC) decoder for Uneven Level Protection (ULP) as described in RFC 5109.

This element will work in combination with an upstream GstRtpStorage element and attempt to recover packets declared lost through custom 'GstRTPPacketLost' events, usually emitted by GstRtpJitterBuffer.

As such, this element cannot be usefully used from the command line, because a reference to the upstream storage object needs to be provided to it through its “storage” property, example programs are available at https://github.com/sdroege/gstreamer-rs/blob/master/examples/src/bin/rtpfecserver.rs and https://github.com/sdroege/gstreamer-rs/blob/master/examples/src/bin/rtpfecclient.rs.

Additionally, the payload types of the protection packets *must* be provided to this element via its “pt” property.

When using GstRtpBin, this element should be inserted through the “request-fec-decoder” signal.

See also: GstRtpUlpFecEnc, GstRtpBin, GstRtpStorage

## Synopsis

### Element Information

plugin | rtp
author | Mikhail Fludkov <misha@pexip.com>
class | Codec/Depayloader/Network/RTP

### Element Pads

name | sink
direction | sink
presence | always
details | application/x-rtp

name | src
direction | source
presence | always
details | application/x-rtp

## Functions

## Types and Values

### struct GstRtpUlpFecDec

    struct GstRtpUlpFecDec;

## Property Details

### The `“pt”` property

      “pt”                       guint

FEC packets payload type.

Flags: Read / Write

Allowed values: <= 127

Default value: 0

### The `“recovered”` property

      “recovered”                guint

The number of recovered packets.

Flags: Read

Default value: 0

### The `“storage”` property

      “storage”                  GObject *

RTP storage.

Flags: Read / Write

### The `“unrecovered”` property

      “unrecovered”              guint

The number of unrecovered packets.

Flags: Read

Default value: 0